+++
title = 'HowTo Buy HDD'
date = 2024-08-17
image = "https://i.extremetech.com/imagery/content-types/017c7K9UIE7N2VnHK8XqLds/images-5.jpg"
+++

We will talk about buying new drives and used ones<!--more-->

But first:

## Statistic

HDD drive have following survival chances (in case of work 24/7-ish):
 - 92% survival chance for first 1.5y at work (due to manafacturing errors) (5.1% per year)
 - 90% survival for 3 years (due to random failure) (1.41% per year)
 - -12% every following year (due to wear-out)
For Enterprise HDDs survival rate may be a higher.

![](https://i.extremetech.com/imagery/content-types/017c7K9UIE7N2VnHK8XqLds/images-5.jpg)

(For at least _some_ Seagate drives, survival rate is 80% after 2 years, and presumably -10% every next year)

Now there is 3 main vendors who actually produce HDDs: WD, Seagate, Toshiba. Other vendors probably just relabelled those 3.

## New

All vendors have bad/good year/batch/etc... So try to pick different drives or from different production years. Also we will pick solely on price+performance+warranty metrics.

### Size

Before that, you should pick size. If you are not running data center then your maximum drive capacity should be 4tb (still depending on usecase but that's general recommendations)  
It will cost more, but it's better to pick 2 drives of lower sizes than 1 bigger to drasticly improve data survival chances

### Performance

That's the most complicated thing because it highly depends from your needs. You can primarly look into RPMs.

"Hot" data - that changes frequently or accessed in random places (Databases, RAID5, Ceph, many users usecase) - need to have faster drives: 7200RPM+, the more IOPS, the better.  
Better IOPS usually have drives with "RAID support".

"Cold" data - that really rarely written and read - be ok with slow drives: 5400RPM. 



### Warranty / Survival time

That's important factor when choosing drive. Usually, it's 3y, but may be 5y. During that time you can expect that you get that drive replaced if it die. Vendors not stupid, they put warranty right before the chances of dying higher. So, warranty may indicate you how much presumably drive have highest survival chances. Be advised that in some countries those warranties may not work or vendor don't work in this country. 

Also it seems that recent drives with helium (without "DO NOT COVER HOLE" label) - lasts more-ish.

If it's hard to change drive in your use case (e.g. RAID, operation critical server...), pick enterprise drive with more warranty. (And __maybe__ not Seagate)

### Price

Pick cheapest.

## Used

Here comes gray area of trust. That's because SMART data can be reset.

Thus your best bet are:
 - __drives with 1.5y-2y (13000-17000h) power on time__ (due to statistic staff)
 - __No CRC errors, read errors, reassigned sectors__ in SMART data
 - if statistically expected that drive survive to its 3y birthday (hereinafter 'lifetime')- then   
`price = cost of new drive / lifetime * current power on time (as % of lifetime)`   
`(min = new drive/3, max = new drive/2)`   
So let's say new cheapest drive costs 100$, min price would be - 33$, max - 50%

Optional:
 - recently produced (<5y)
 - WD (that's my personal choice, i think they tend to produce drives with better quality control, so less drives die due to manufacturing errors)
 - Enterprise class (althou failure rates are "very much similar" they tend to be in worse operating environment, e.g. server room, so ["don't scream at the drives, they'll get discouraged"](https://www.youtube.com/watch?v=tDacjrSCeq4&pp=ygUKaGRkIHNjcmVhbQ%3D%3D))

 
### Sellers

As you understand there is no warranty (as SMART don't indicate reliability of drive) and drive may fail few weeks later.   
So ask to pack drive nicely.

Seller can have 97% positive reviews while scamming every 30th customer.  so don't look at positive reviews - look only at negatives.
![](https://www.explainxkcd.com/wiki/images/4/4c/a-minus-minus.png)

{{< source >}}
https://www.reddit.com/r/DataHoarder/comments/1eg0kpf/brand_preference/
https://www.reddit.com/r/DataHoarder/comments/k4rc7a/comment/gedlp75/?utm_source=share&utm_medium=web3x&utm_name=web3xcss&utm_term=1&utm_content=share_button
https://www.extremetech.com/computing/170748-how-long-do-hard-drives-actually-live-for
https://www.backblaze.com/blog/hard-drive-life-expectancy/
https://www.backblaze.com/blog/helium-filled-hard-drive-failure-rates/
https://darwinsdata.com/are-helium-hard-drives-worth-it/
https://en.wikipedia.org/wiki/Hard_disk_drive
{{< /source >}}
